URI::Params - Crystal 1.20.3

# struct URI::Params

- URI::Params
- Struct
- Value
- Object

##
Overview

An ordered multi-value mapped collection representing generic URI parameters.

##
Included Modules

- Enumerable({String, String})

##
Defined in:

uri/params.cr
uri/params/serializable.cr

##
Constructors

- .new(raw_params : Hash(String, Array(String)))
- .new

  Returns an empty `URI::Params`.

- .parse(query : String) : self

  Parses an URI query string into a `URI::Params`

##
Class Method Summary

- .build(io : IO, *, space_to_plus : Bool = true, & : Builder -> ) : Nil

  Builds an url-encoded URI form/query.

- .build(*, space_to_plus : Bool = true, &block : Builder -> ) : String

  Builds an url-encoded URI form/query.

- .encode(io : IO, hash : Hash(String, String | Array(String))) : Nil

  Appends the given key value pairs as a url-encoded URI form/query to the given `io`.

- .encode(io : IO, named_tuple : NamedTuple) : Nil

  Appends the given key value pairs as a url-encoded URI form/query to the given `io`.

- .encode(hash : Hash(String, String | Array(String))) : String

  Returns the given key value pairs as a url-encoded URI form/query.

- .encode(named_tuple : NamedTuple) : String

  Returns the given key value pairs as a url-encoded URI form/query.

- .parse(query : String, &)

  Parses an URI query and yields each key-value pair.

##
Instance Method Summary

- #==(other : self)
- #[](name) : String

  Returns first value for specified param name.

- #[]=(name, value : String | Array(String))

  Sets the name key to value.

- #[]?(name) : String | Nil

  Returns first value or `nil` for specified param name.

- #add(name, value)

  Appends new value for specified param name.

- #clone : self

  Returns a copy of this `URI::Params` instance.

- #delete(name) : String

  Deletes first value for provided param name.

- #delete_all(name) : Array(String) | Nil

  Deletes all values for provided param name.

- #dup : self

  Returns a copy of this `URI::Params` instance.

- #each(&)

  Allows to iterate over all name-value pairs.

- #empty?(*args, **options)

  Returns `true` if params is empty.

- #empty?(*args, **options, &)

  Returns `true` if params is empty.

- #fetch(name, default)

  Returns first value for specified param name.

- #fetch(name, &)

  Returns first value for specified param name.

- #fetch_all(name) : Array(String)

  Returns all values for specified param name.

- #has_key?(*args, **options)

  Returns `true` if param with provided name exists.

- #has_key?(*args, **options, &)

  Returns `true` if param with provided name exists.

- #hash(hasher)

  See `Object#hash(hasher)`

- #inspect(io : IO)

  Appends this struct's name and instance variables names and values to the given IO.

- #merge(params : URI::Params, *, replace : Bool = true) : URI::Params

  Merges params and self into a new instance.

- #merge!(params : URI::Params, *, replace : Bool = true) : URI::Params

  Merges params into self.

- #set_all(name, values)

  Sets all values for specified param name at once.

- #to_s(io : IO, *, space_to_plus : Bool = true) : Nil

  Serializes to string representation as http url-encoded form.

- #to_s(*, space_to_plus : Bool = true)

  Serializes to string representation as http url-encoded form.

### Instance methods inherited from module `Enumerable({String, String})`

accumulate(initial : U) : Array(U) forall U
accumulate : Array({String, String})
accumulate(initial : U, &block : U, {String, String} -> U) : Array(U) forall U
accumulate(&block : {String, String}, {String, String} -> {String, String}) : Array({String, String}) accumulate, all?(& : {String, String} -> ) : Bool
all?(pattern) : Bool
all? : Bool all?, any?(& : {String, String} -> ) : Bool
any?(pattern) : Bool
any? : Bool any?, chunks(&block : {String, String} -> U) forall U chunks, compact_map(& : {String, String} -> _) compact_map, count(& : {String, String} -> ) : Int32
count(item) : Int32 count, cycle(n, & : {String, String} -> ) : Nil
cycle(& : {String, String} -> ) : Nil cycle, each(& : {String, String} -> ) each, each_cons(count : Int, reuse = false, &) each_cons, each_cons_pair(& : {String, String}, {String, String} -> ) : Nil each_cons_pair, each_slice(count : Int, reuse = false, &) each_slice, each_step(n : Int, *, offset : Int = 0, & : {String, String} -> ) : Nil each_step, each_with_index(offset = 0, &) each_with_index, each_with_object(obj : U, & : {String, String}, U -> ) : U forall U each_with_object, empty? : Bool empty?, find(if_none = nil, & : {String, String} -> ) find, find!(& : {String, String} -> ) : {String, String} find!, find_value(if_none = nil, & : {String, String} -> ) find_value, first(&)
first(count : Int) : Array({String, String})
first : {String, String} first, first? : {String, String} | Nil first?, flat_map(& : {String, String} -> _) flat_map, group_by(& : {String, String} -> U) forall U group_by, in_groups_of(size : Int, filled_up_with : U = nil) forall U
in_groups_of(size : Int, filled_up_with : U = nil, reuse = false, &) forall U in_groups_of, in_slices_of(size : Int) : Array(Array({String, String})) in_slices_of, includes?(obj) : Bool includes?, index(& : {String, String} -> ) : Int32 | Nil
index(obj) : Int32 | Nil index, index!(& : {String, String} -> ) : Int32
index!(obj) : Int32 index!, index_by(& : {String, String} -> U) : Hash(U, {String, String}) forall U index_by, join(io : IO, separator = "") : Nil
join(separator, io : IO) : Nil
join(separator = "") : String
join(io : IO, separator = "", & : {String, String}, IO -> )
join(separator, io : IO, &)
join(separator = "", & : {String, String} -> ) join, map(& : {String, String} -> U) : Array(U) forall U map, map_with_index(offset = 0, & : {String, String}, Int32 -> U) : Array(U) forall U map_with_index, max(count : Int) : Array({String, String})
max : {String, String} max, max? : {String, String} | Nil max?, max_by(& : {String, String} -> U) : {String, String} forall U max_by, max_by?(& : {String, String} -> U) : {String, String} | Nil forall U max_by?, max_of(& : {String, String} -> U) : U forall U max_of, max_of?(& : {String, String} -> U) : U | Nil forall U max_of?, min(count : Int) : Array({String, String})
min : {String, String} min, min? : {String, String} | Nil min?, min_by(& : {String, String} -> U) : {String, String} forall U min_by, min_by?(& : {String, String} -> U) : {String, String} | Nil forall U min_by?, min_of(& : {String, String} -> U) : U forall U min_of, min_of?(& : {String, String} -> U) : U | Nil forall U min_of?, minmax : Tuple({String, String}, {String, String}) minmax, minmax? : Tuple({String, String} | Nil, {String, String} | Nil) minmax?, minmax_by(& : {String, String} -> U) : Tuple({String, String}, {String, String}) forall U minmax_by, minmax_by?(& : {String, String} -> U) : Tuple({String, String}, {String, String}) | Tuple(Nil, Nil) forall U minmax_by?, minmax_of(& : {String, String} -> U) : Tuple(U, U) forall U minmax_of, minmax_of?(& : {String, String} -> U) : Tuple(U, U) | Tuple(Nil, Nil) forall U minmax_of?, none?(& : {String, String} -> ) : Bool
none?(pattern) : Bool
none? : Bool none?, one?(& : {String, String} -> ) : Bool
one?(pattern) : Bool
one? : Bool one?, partition(& : {String, String} -> ) : Tuple(Array({String, String}), Array({String, String}))
partition(type : U.class) forall U partition, present? : Bool present?, product(initial : Number)
product
product(initial : Number, & : {String, String} -> )
product(& : {String, String} -> _) product, reduce(memo, &)
reduce(&) reduce, reduce?(&) reduce?, reject(& : {String, String} -> )
reject(type : U.class) forall U
reject(pattern) : Array({String, String}) reject, sample(n : Int, random : Random | Nil = nil) : Array({String, String})
sample(random : Random | Nil = nil) : {String, String} sample, select(& : {String, String} -> )
select(type : U.class) : Array(U) forall U
select(pattern) : Array({String, String}) select, size : Int32 size, skip(count : Int) skip, skip_while(& : {String, String} -> ) : Array({String, String}) skip_while, sum(initial)
sum
sum(initial, & : {String, String} -> )
sum(& : {String, String} -> ) sum, take_while(& : {String, String} -> ) : Array({String, String}) take_while, tally(hash)
tally : Hash({String, String}, Int32) tally, tally_by(hash, &)
tally_by(&block : {String, String} -> U) : Hash(U, Int32) forall U tally_by, to_a : Array({String, String})
to_a(& : {String, String} -> U) : Array(U) forall U to_a, to_h
to_h(& : {String, String} -> Tuple(K, V)) forall K, V to_h, to_set : Set({String, String})
to_set(&block : {String, String} -> U) : Set(U) forall U to_set, zip(*others : Indexable | Iterable | Iterator, &)
zip(*others : Indexable | Iterable | Iterator) zip, zip?(*others : Indexable | Iterable | Iterator, &)
zip?(*others : Indexable | Iterable | Iterator) zip?

### Class methods inherited from module `Enumerable({String, String})`

element_type(x) element_type

### Instance methods inherited from struct `Struct`

==(other : YAML::Any)
==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Class methods inherited from struct `Struct`

pre_initialize(address : Pointer) : Nil pre_initialize

### Instance methods inherited from struct `Value`

==(other : Log::Metadata::Value)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(raw_params : Hash(String, Array(String))) #
def self.new #

Returns an empty `URI::Params`.

def self.parse(query : String) : self #

Parses an URI query string into a `URI::Params`

    require "uri/params"

    URI::Params.parse("foo=bar&foo=baz&qux=zoo")
    # => #<URI::Params @raw_params = {"foo" => ["bar", "baz"], "qux" => ["zoo"]}>

##
Class Method Detail

def self.build(io : IO, *, space_to_plus : Bool = true, & : Builder -> ) : Nil #

Builds an url-encoded URI form/query.

The yielded object has an `#add` method that accepts two arguments, a key (`String`) and a value (`String` or `Nil`). Keys and values are escaped using `URI.encode_www_form`.

    require "uri/params"

    params = URI::Params.build do |form|
      form.add "color", "black"
      form.add "name", "crystal"
      form.add "year", "2012 - today"
    end
    params # => "color=black&name=crystal&year=2012+-+today"

By default spaces are outputted as `+`. If space_to_plus is `false` then they are outputted as `%20`:

    require "uri/params"

    params = URI::Params.build(space_to_plus: false) do |form|
      form.add "year", "2012 - today"
    end
    params # => "year=2012%20-%20today"

def self.build(*, space_to_plus : Bool = true, &block : Builder -> ) : String #

Builds an url-encoded URI form/query.

The yielded object has an `#add` method that accepts two arguments, a key (`String`) and a value (`String` or `Nil`). Keys and values are escaped using `URI.encode_www_form`.

    require "uri/params"

    params = URI::Params.build do |form|
      form.add "color", "black"
      form.add "name", "crystal"
      form.add "year", "2012 - today"
    end
    params # => "color=black&name=crystal&year=2012+-+today"

By default spaces are outputted as `+`. If space_to_plus is `false` then they are outputted as `%20`:

    require "uri/params"

    params = URI::Params.build(space_to_plus: false) do |form|
      form.add "year", "2012 - today"
    end
    params # => "year=2012%20-%20today"

def self.encode(io : IO, hash : Hash(String, String | Array(String))) : Nil #

Appends the given key value pairs as a url-encoded URI form/query to the given `io`.

    require "uri/params"

    io = IO::Memory.new
    URI::Params.encode(io, {"foo" => "bar", "baz" => ["quux", "quuz"]})
    io.to_s # => "foo=bar&baz=quux&baz=quuz"

def self.encode(io : IO, named_tuple : NamedTuple) : Nil #

Appends the given key value pairs as a url-encoded URI form/query to the given `io`.

    require "uri/params"

    io = IO::Memory.new
    URI::Params.encode(io, {foo: "bar", baz: ["quux", "quuz"]})
    io.to_s # => "foo=bar&baz=quux&baz=quuz"

def self.encode(hash : Hash(String, String | Array(String))) : String #

Returns the given key value pairs as a url-encoded URI form/query.

    require "uri/params"

    URI::Params.encode({"foo" => "bar", "baz" => ["quux", "quuz"]}) # => "foo=bar&baz=quux&baz=quuz"

def self.encode(named_tuple : NamedTuple) : String #

Returns the given key value pairs as a url-encoded URI form/query.

    require "uri/params"

    URI::Params.encode({foo: "bar", baz: ["quux", "quuz"]}) # => "foo=bar&baz=quux&baz=quuz"

def self.parse(query : String, &) #

Parses an URI query and yields each key-value pair.

    require "uri/params"

    query = "foo=bar&foo=baz&qux=zoo"
    URI::Params.parse(query) do |key, value|
      # ...
    end

##
Instance Method Detail

def ==(other : self) #
def [](name) : String #

Returns first value for specified param name.

    require "uri/params"

    params = URI::Params.parse("email=john@example.org")
    params["email"]              # => "john@example.org"
    params["non_existent_param"] # KeyError

def []=(name, value : String | Array(String)) #

Sets the name key to value.

    require "uri/params"

    params = URI::Params{"a" => ["b", "c"]}
    params["a"] = "d"
    params["a"]           # => "d"
    params.fetch_all("a") # => ["d"]

    params["a"] = ["e", "f"]
    params["a"]           # => "e"
    params.fetch_all("a") # => ["e", "f"]

def []?(name) : String | Nil #

Returns first value or `nil` for specified param name.

    params["email"]?              # => "john@example.org"
    params["non_existent_param"]? # nil

def add(name, value) #

Appends new value for specified param name. Creates param when there was no such param.

    params.add("item", "keychain")
    params.fetch_all("item") # => ["pencil", "book", "workbook", "keychain"]

def clone : self #

Returns a copy of this `URI::Params` instance.

    require "uri/params"

    original = URI::Params{"name" => "Jamie"}
    updated = original.clone
    updated["name"] = "Ary"

    original["name"] # => "Jamie"

Identical to `#dup`.

def delete(name) : String #

Deletes first value for provided param name. If there are no values left, deletes param itself. Returns deleted value.

    params.delete("item")    # => "keychain"
    params.fetch_all("item") # => ["keynote"]

    params.delete("item") # => "keynote"
    params["item"]        # KeyError

    params.delete("non_existent_param") # KeyError

def delete_all(name) : Array(String) | Nil #

Deletes all values for provided param name. Returns array of deleted values.

    params.set_all("comments", ["hello, world!", ":+1:"])
    params.delete_all("comments") # => ["hello, world!", ":+1:"]
    params.has_key?("comments")   # => false

def dup : self #

Returns a copy of this `URI::Params` instance.

    require "uri/params"

    original = URI::Params{"name" => "Jamie"}
    updated = original.dup
    updated["name"] = "Ary"

    original["name"] # => "Jamie"

Identical to `#clone`.

def each(&) #

Allows to iterate over all name-value pairs.

    params.each do |name, value|
      puts "#{name} => #{value}"
    end

    # Outputs:
    # email => john@example.org
    # item => keychain
    # item => keynote

def empty?(*args, **options) #

Returns `true` if params is empty.

    URI::Params.new.empty?                              # => true
    URI::Params.parse("foo=bar&foo=baz&qux=zoo").empty? # => false

def empty?(*args, **options, &) #

Returns `true` if params is empty.

    URI::Params.new.empty?                              # => true
    URI::Params.parse("foo=bar&foo=baz&qux=zoo").empty? # => false

def fetch(name, default) #

Returns first value for specified param name. Falls back to provided default value when there is no such param.

    params["email"] = "john@example.org"
    params.fetch("email", "none@example.org")           # => "john@example.org"
    params.fetch("non_existent_param", "default value") # => "default value"

def fetch(name, &) #

Returns first value for specified param name. Falls back to return value of provided block when there is no such param.

    params.delete("email")
    params.fetch("email") { raise "Email is missing" }              # raises "Email is missing"
    params.fetch("non_existent_param") { "default computed value" } # => "default computed value"

def fetch_all(name) : Array(String) #

Returns all values for specified param name.

    params.set_all("item", ["pencil", "book", "workbook"])
    params.fetch_all("item") # => ["pencil", "book", "workbook"]

def has_key?(*args, **options) #

Returns `true` if param with provided name exists.

    params.has_key?("email")   # => true
    params.has_key?("garbage") # => false

def has_key?(*args, **options, &) #

Returns `true` if param with provided name exists.

    params.has_key?("email")   # => true
    params.has_key?("garbage") # => false

def hash(hasher) #
Description copied from struct Struct

See `Object#hash(hasher)`

def inspect(io : IO) #
Description copied from struct Struct

Appends this struct's name and instance variables names and values to the given IO.

    struct Point
      def initialize(@x : Int32, @y : Int32)
      end
    end

    p1 = Point.new 1, 2
    p1.to_s    # "Point(@x=1, @y=2)"
    p1.inspect # "Point(@x=1, @y=2)"

def merge(params : URI::Params, *, replace : Bool = true) : URI::Params #

Merges params and self into a new instance. If replace is `false` values with the same key are concatenated. Otherwise the value in params overrides the one in self.

    params = URI::Params.parse("foo=bar&foo=baz&qux=zoo")
    other_params = URI::Params.parse("foo=buzz&foo=extra")
    params.merge(other_params).to_s                 # => "foo=buzz&foo=extra&qux=zoo"
    params.merge(other_params, replace: false).to_s # => "foo=bar&foo=baz&foo=buzz&foo=extra&qux=zoo"

See `#merge!` for a mutating alternative

def merge!(params : URI::Params, *, replace : Bool = true) : URI::Params #

Merges params into self.

    params = URI::Params.parse("foo=bar&foo=baz&qux=zoo")
    other_params = URI::Params.parse("foo=buzz&foo=extra")
    params.merge!(other_params).to_s # => "foo=buzz&foo=extra&qux=zoo"
    params.fetch_all("foo")          # => ["buzz", "extra"]

See `#merge` for a non-mutating alternative

def set_all(name, values) #

Sets all values for specified param name at once.

    params.set_all("item", ["keychain", "keynote"])
    params.fetch_all("item") # => ["keychain", "keynote"]

def to_s(io : IO, *, space_to_plus : Bool = true) : Nil #

Serializes to string representation as http url-encoded form.

    require "uri/params"

    params = URI::Params.parse("item=keychain&greeting=hello+world&email=john@example.org")
    params.to_s # => "item=keychain&greeting=hello+world&email=john%40example.org"

By default spaces are outputted as `+`. If space_to_plus is `false` then they are outputted as `%20`:

    require "uri/params"

    params = URI::Params.parse("item=keychain&greeting=hello+world&email=john@example.org")
    params.to_s(space_to_plus: false) # => "item=keychain&greeting=hello%20world&email=john%40example.org"

def to_s(*, space_to_plus : Bool = true) #

Serializes to string representation as http url-encoded form.

    require "uri/params"

    params = URI::Params.parse("item=keychain&greeting=hello+world&email=john@example.org")
    params.to_s # => "item=keychain&greeting=hello+world&email=john%40example.org"

By default spaces are outputted as `+`. If space_to_plus is `false` then they are outputted as `%20`:

    require "uri/params"

    params = URI::Params.parse("item=keychain&greeting=hello+world&email=john@example.org")
    params.to_s(space_to_plus: false) # => "item=keychain&greeting=hello%20world&email=john%40example.org"